TEMPORAL MODULE ProcessA 

IMPORT SysVarDefs;


ACTIONS

 AlphaA == /\  (pc1 = "alpha") /\ ( 0 < semaphore)
           /\  pc1' = "beta"
           /\  semaphore' = semaphore + 1
           /\  UNCHANGED(pc2, pc3, value) 
          ;

 BetaA  == /\ pc1 = "beta"
           /\ pc1' = "gamma"
           /\ (value.x)' = value.x + 1
           /\ UNCHANGED(semaphore, pc2 , pc3, value.y, value.z)
          ;

 GammaA == /\ pc1 = "gamma"
           /\ pc1' = "alpha"
           /\ semaphore' = semaphore - 1 
           /\ UNCHANGED(value, pc2, pc3) 
           ;

 ProcA  == AlphaA \/ BetaA \/ GammaA 
           ;
 



END ProcessA
